﻿using System;
using Syncfusion.EJ.ReportViewer;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Syncfusion.Reports.EJ;
using System.Collections;
//using Syncfusion.EJ.RDL;

namespace jssample
{
    public class ReportApiController : ApiController, IReportController
    {
        //Post action for processing the rdl/rdlc report
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            //var _serverPro = new Syncfusion.Server.Reports.UMP();
            return ReportHelper.ProcessReport(jsonResult, this);
        }

        //Get action for getting resources from the report
        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        //Method will be called when initialize the report options before start processing the report        
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            //if (reportOption.ReportModel.ReportPath.Contains("RSSMRP01.rdlc"))
            //{
            //    reportOption.ReportModel.ReportPath = System.Web.HttpContext.Current.Server.MapPath("~/App_Data/RSSMRP01.rdlc");
            //}
        }

        //Method will be called when reported is loaded
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
            //if (reportOption.ReportModel.ReportPath.Contains("RSSMRP01.rdlc"))
            //{
            //    reportOption.ReportModel.DataSources.Clear();
            //    reportOption.ReportModel.DataSources.Add(new ReportDataSource { Name = "DataSet1", Value = jssample.User.GetData() });
            //}
        }
    }

    public class User
    {
        public string USER_ID { get; set; }
        public string USER_NAME { get; set; }

        public static IList GetData()
        {
            List<User> datas = new List<User>();
            User data = null;
            data = new User()
            {
                USER_ID = "01",
                USER_NAME = "นายกฤตติกร ดีรักษา"
            };
            datas.Add(data);
            return datas;
        }
    }
}